#include "process_secs.h"
#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif
#ifdef HAVE_SYS_RESOURCE_H
#include <sys/resource.h>
double get_process_seconds(void)
{
    struct rusage r;
	getrusage(0, &r);
	return r.ru_utime.tv_sec + r.ru_stime.tv_sec + (r.ru_utime.tv_usec + r.ru_stime.tv_usec) / 1000000.0;
}
#else if defined(_WIN32) || defined(__WIN32__) || defined(WIN32)
#include <windows.h>
double get_process_seconds(void)
{
    FILETIME ctime, etime, utime, stime;
    HANDLE myProcess = GetCurrentProcess();
    GetProcessTimes(myProcess, &ctime, &etime, &utime, &stime);
    ULARGE_INTEGER utime64, stime64;
    utime64.LowPart = utime.dwLowDateTime;
    utime64.HighPart = utime.dwHighDateTime;
    stime64.LowPart = stime.dwLowDateTime;
    stime64.HighPart = stime.dwHighDateTime;
	return (utime64.QuadPart + stime64.QuadPart) / 10000000.0;
}
#endif