MUSCLE 3.8.31 for Windows
=========================

Source Code Modifications
-------------------------

A number of modifications were required to compile MUSCLE
under MinGW.  Although MUSCLE was supported under both
Windows and Linux, it assumed some features of Microsoft
Visual C++ would be available on Windows.  When it is compiled
with GCC/MinGW-w64, these features are not available.

1.	The `#ifdef` on line 3 of `globalsother.cpp` was changed from

		#if !defined(__linux__) && !defined(_MSC_VER) && !defined(__MACH__)
		
	to
		
		#if	!defined(__linux__) && !defined(_MSC_VER) && !defined(__MACH__) && !defined(__MINGW64__) && !defined(__MINGW32__)

	so as to "comment out" the rest of the file when compiled on MinGW.
2.	In `globalswin32.cpp`, the line

		BOOL bOk = GetProcessMemoryInfo(hProc, &PMC, sizeof(PMC));
	
	was replaced with
	
		#if PSAPI_VERSION == 1
			BOOL bOk = GetProcessMemoryInfo(hProc, &PMC, sizeof(PMC));
		#elif PSAPI_VERSION == 2
			BOOL bOk = K32GetProcessMemoryInfo(hProc, &PMC, sizeof(PMC));
		#endif
	
	to be compatible with version 2 of the Windows Process Status API.
	
3.	In `muscle.h`,

		#if _WIN32
		
	was replaced with
	
		#if _WIN32 && !defined(__MINGW64__) && !defined(__MINGW32__)
		
	so that the MinGW-defined function `log2` will not be redefined.
	
4.	In `timing.h`,

		#if _WIN32
		
	was replaced with
	
		#if _WIN32 && !defined(__MINGW64__) && !defined(__MINGW32__)
		
	so as to comment out the entire file on MinGW, where it is not
	necessary.
	
5.	The `Makefile` was adjusted so as to make use of the dependency
tracking facilities provided by `make`.  The new makefile defines
a rule for making a C++ file into an object file, and a linking target
for `muscle` itself.  It no longer invokes a shell script to run G++ in
a loop.